//set up L293D
int motor1Pin1 = 6;    // pin 2 (Input 1)  du L293D
int motor1Pin2 = 8;    // pin 7 (Input 2) du L293D
int enablePin = 10;     // pin 1 (Enable 1) du L293D
//set up vitesse ventilo
int ventiloSpeed = 0;
int newVentiloSpeed=0;
int time = 200;
//set up serial
float incomingByte=162.4;
float oldIncomingByte=incomingByte;
int retourTaux =0;
int x=1;
//set up LCD
#include <LiquidCrystal.h>
#include <stdio.h>

// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);



void setup() {
  // set up the number of columns and rows on the LCD 

  lcd.begin(16, 2);

  Serial.begin(9600);

  pinMode(motor1Pin1, OUTPUT);//controle un sens
  //pinMode(motor1Pin2, OUTPUT);//controle l'autre sens
  pinMode(enablePin, OUTPUT);
  pinMode(13, OUTPUT);
  //commande par port serie manuellement

  /* while (Serial.available() < 0) {
   //On lit le byte qui arrive sur le port série
   oldIncomingByte = Serial.read();
   delay(10);
   };
   
   // Mettre la broche Enable a high comme ca le moteur tourne
   
   
   for (int i=0; i<=ventiloSpeed; i++){
   analogWrite(motor1Pin1, i);   // mettre pin 2 a 293D low
   delay(time);
   }
   ;*/
  digitalWrite(enablePin, HIGH); 

}

void loop() {
  /*int serieDispo = Serial.available();
   while (serieDispo < 0) {
   //On lit le byte qui arrive sur le port série
   incomingByte = Serial.read();
   };*/
  //commande par port serie manuellement
  if (Serial.available()> 0) {

    char valeur = Serial.read();

    switch(valeur) {
    case'a' :
      incomingByte = incomingByte + 0.1;
      Serial.print("incomingByte");
      Serial.println(incomingByte);
      Serial.print("oldIncomingByte");
      Serial.println(oldIncomingByte);
      break;
    case'b' :
      incomingByte = incomingByte - 0.1;
      Serial.print ("incomingByte");
      Serial.println(incomingByte);
      Serial.print("oldIncomingByte");
      Serial.println(oldIncomingByte);
      break;
    case'd' :
      Serial.print(":)");
      break;
    default :
      Serial.print("???");
    };
    //calcule difference entre ancien et nouveau taux 
    if (incomingByte != oldIncomingByte){
      {
        retourTaux = int ((incomingByte - oldIncomingByte)*100);
        Serial.print("retour");
        Serial.println(retourTaux);
        //calcule nouvelle vitesse

        newVentiloSpeed = ventiloSpeed + (retourTaux*5);
        if (newVentiloSpeed <0){newVentiloSpeed=0;};
        if (newVentiloSpeed >250){newVentiloSpeed=250;};
        Serial.print("ventilo");
        Serial.println(ventiloSpeed);
        Serial.print("newVentilo");
        Serial.println(newVentiloSpeed);
        //verification si difference est possitive ou negative
        if (retourTaux>0){
            x=1;
        }
        else{
            x=-1;
        };
        //variasation progressive du changement de vitesse

        while (newVentiloSpeed != ventiloSpeed){
          ventiloSpeed = ventiloSpeed + x;
          analogWrite(motor1Pin1, ventiloSpeed);
          Serial.print("chanegement ventilo");
          Serial.println(newVentiloSpeed);
          Serial.print("ventilo actuel");
          Serial.println(ventiloSpeed);
        };
        //revalorisation des variables      
        newVentiloSpeed = ventiloSpeed;
        oldIncomingByte = incomingByte;
      };
    }
  }
  //LCD
  char str[6];
  lcd.setCursor(0, 0);
  lcd.print("Goldman S.");
  // set the cursor to column 0, line 1
  // line 1 is the second row, since counting begins with 0
  lcd.setCursor(11, 0);
  // print to the second line
  // faire recherche    sprintf(str,"%5.1f",3.51); //incomingByte);
  lcd.print(incomingByte);
  lcd.setCursor(0, 1);
  lcd.print("Ventillo.");
  // set the cursor to column 0, line 1
  // line 1 is the second row, since counting begins with 0
  lcd.setCursor(12, 1);
  // print to the second line

  sprintf(str,"%4d",ventiloSpeed);
  lcd.print(str);

  //fin
}











